﻿Public Class Form1

    Dim player_score As Integer = 0     '記錄玩者的勝數
    Dim computer_score As Integer = 0   '記錄電腦的勝數
    Dim game As Integer = 0             '記錄所玩的總局數

    '3. 讓使用者於遊戲前輸入最大遊戲局數

    '2. 製作一個記錄每局輸贏的陣列 (5 局)


    '「猜拳」按鈕的執行程序
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim guess As Integer            '記錄隨機數的整數變量

        '1. 避免使用者未選擇任何RadioButton便按「猜拳」按鈕
        '關鍵：先檢查三個RadioButton的Checked是否都是False
        '       → 於畫面彈出提示 (MsgBox)
        '       → 中止執行 Button1_Click (Exit Sub)

        Randomize()                     '初始化隨機數
        guess = Int(3 * Rnd()) + 1      '把介於1-3的隨機數，記錄於guess內

        If guess = 1 Then               '按著隨機數的數值，顯示合適的包剪搥圖片
            PictureBox1.Visible = True
        ElseIf guess = 2 Then
            PictureBox2.Visible = True
        ElseIf guess = 3 Then
            PictureBox3.Visible = True
        End If

        If RadioButton1.Checked = True Then     '按著玩者選擇的RadioButton，顯示合適的包剪搥圖片
            PictureBox6.Visible = True
        ElseIf RadioButton2.Checked = True Then
            PictureBox4.Visible = True
        ElseIf RadioButton3.Checked = True Then
            PictureBox5.Visible = True
        End If

        '判斷打和、玩者勝、電腦勝的情況
        If (RadioButton1.Checked = True And guess = 1) Or (RadioButton2.Checked = True And guess = 2) Or (RadioButton3.Checked = True And guess = 3) Then
            Label1.Text = "打和"
            '2. 記錄「和」於陣列內
        Else
            If (RadioButton1.Checked = True And guess = 3) Or (RadioButton2.Checked = True And guess = 1) Or (RadioButton3.Checked = True And guess = 2) Then
                Label1.Text = "你贏了！"
                player_score += 1
                Label4.Text = player_score
                '2. 記錄「勝」於陣列內
            Else
                Label1.Text = "我贏了！"
                computer_score += 1
                Label5.Text = computer_score
                '2. 記錄「負」於陣列內
            End If

        End If

        game += 1           '把記錄遊戲局數的變量 +1
        Label6.Text = game  '顯示更新了的遊戲局數

        '2. 當完成5局遊戲時，在畫面彈出提示，並詢問使用者是否編製輸贏記錄
        '   若編製記錄，便於畫面彈出一對話方框顯示所有記錄
        '   關鍵：  彈出「是否編製輸贏記錄」 (MsgBox)
        '           製作記錄對話方框 (Dialog)
        '           製作記錄內每局文字 (AppendText)
        '           顯示每局的輸贏 (stat陣列、for循環)
        '           顯示對話方框 (Dialog.show() )


        RadioButton1.Enabled = False    '清除使用者選擇過的RadioButton
        RadioButton2.Enabled = False
        RadioButton3.Enabled = False

        Button1.Enabled = False         '令「猜拳」按鈕失效 ← 見Button2_Click程序
        Button2.Enabled = True          '令「再來一次」按鈕生效


    End Sub

    '「再來一次」按鈕的執行程序
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        RadioButton1.Checked = False
        RadioButton2.Checked = False
        RadioButton3.Checked = False
        PictureBox1.Visible = False
        PictureBox2.Visible = False
        PictureBox3.Visible = False
        PictureBox4.Visible = False
        PictureBox5.Visible = False
        PictureBox6.Visible = False

        Label1.Text = ""

        RadioButton1.Enabled = True
        RadioButton2.Enabled = True
        RadioButton3.Enabled = True

        Button1.Enabled = True
        Button2.Enabled = False
        Button3.Enabled = True
    End Sub

    '「清除記錄」按鈕的執行程序
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        RadioButton1.Checked = False
        RadioButton2.Checked = False
        RadioButton3.Checked = False
        PictureBox1.Visible = False
        PictureBox2.Visible = False
        PictureBox3.Visible = False
        PictureBox4.Visible = False
        PictureBox5.Visible = False
        PictureBox6.Visible = False

        Label1.Text = ""

        RadioButton1.Enabled = True
        RadioButton2.Enabled = True
        RadioButton3.Enabled = True

        Button1.Enabled = True
        Button2.Enabled = False

        MsgBox("你共玩了：" & game & "局" & vbNewLine & "你勝了：" & player_score & "局" & vbNewLine & "你的勝出槪率：" & Math.Round(player_score / game * 100, 2) & "%", MsgBoxStyle.Information, "總結")

        computer_score = 0
        game = 0
        player_score = 0

        Label4.Text = 0
        Label5.Text = 0
        Label6.Text = 0

        '2. 清除陣列內的記錄

    End Sub

    '3. 程式一開始時要電腦執行的程序
    '   關鍵：  於程序開始前執行 (Form_Load程序)
    '           輸入局數的對話框 (InputBox)
    '           把字串轉為整數   (Val)
    '           重新定義陣列     (ReDim)
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
